on Open.DAI.VR.Mac.Pano
  global gVR.MovieOpen, gPanoMovieID
  CloseNavMovie.mac()
  set the ink of sprite 3 to 0
  set the ink of sprite 4 to 0
  updateStage()
  set the ink of sprite 3 to 1
  set the ink of sprite 4 to 1
  updateStage()
  OpenPanoMovie.mac(the text of cast "Pano Filename", 3, 1)
  if gPanoMovieID <> EMPTY then
    go(the frame)
    ShowPanoMovie.mac()
    set gVR.MovieOpen to 1
  else
    updateStage()
    alert("Can't open file:" & RETURN & RETURN & QUOTE & the text of cast "Pano Filename" & QUOTE & RETURN & RETURN & "as a panoramic movie.")
  end if
end

on Close.DAI.VR.Mac.Pano
  global gVR.MovieOpen
  ClosePanoMovie.mac()
  set the ink of sprite 3 to 0
  updateStage()
  set the ink of sprite 3 to 1
  updateStage()
  set gVR.MovieOpen to 0
end

on OpenPanoMovie.mac pFilename, pSpriteNum, pShowOnOpen
  global gPanoMovieID, gPathName
  ClosePanoMovie.mac()
  set tPanoRect to the left of sprite pSpriteNum & "," & the top of sprite pSpriteNum & "," & the right of sprite pSpriteNum & "," & the bottom of sprite pSpriteNum
  set gPanoMovieID to PanoMovie("openMovie", "Direct", pFilename, tPanoRect)
  if gPanoMovieID contains "error" then
    put gPanoMovieID
    set gPanoMovieID to EMPTY
    beep()
    exit
  end if
  InitPanoCallbacks.mac()
  if pShowOnOpen then
    PanoMovie("Direct", gPanoMovieID, "update")
  end if
end

on InitPanoCallbacks.mac
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    PanoMovie("Direct", gPanoMovieID, "set", "mouseOverHandler", EMPTY)
    PanoMovie("Direct", gPanoMovieID, "set", "rolloverHotSpotHandler", "DAI.VR.MacRolloverHandler")
    PanoMovie("Direct", gPanoMovieID, "set", "mouseDownHandler", "DAI.VR.MacMouseDownHandler")
    PanoMovie("Direct", gPanoMovieID, "set", "panZoomStartHandler", EMPTY)
    PanoMovie("Direct", gPanoMovieID, "set", "mouseStillDownHandler", EMPTY)
    PanoMovie("Direct", gPanoMovieID, "set", "nodeLeaveHandler", EMPTY)
  end if
end

on ShowPanoMovie.mac pQuality
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    if not voidp(pQuality) then
      PanoMovie("Direct", gPanoMovieID, "set", "quality", pQuality)
    end if
    PanoMovie("Direct", gPanoMovieID, "update")
  end if
end

on SetPanoNode.mac pNodeID, pUpdate, pQuality
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    PanoMovie("Direct", gPanoMovieID, "set", "nodeID", pNodeID)
    if not voidp(pQuality) then
      PanoMovie("Direct", gPanoMovieID, "set", "quality", pQuality)
    end if
    if pUpdate then
      PanoMovie("Direct", gPanoMovieID, "Update")
    end if
  end if
end

on SwingPanoMovie.mac pHPan, pVPan, pZoom, pSwingSpeed, pSwingQuality, pFinalQuality
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    PanoMovie("Direct", gPanoMovieID, "set", "zoomAngle", string(pZoom))
    PanoMovie("Direct", gPanoMovieID, "set", "vPanAngle", string(pVPan))
    PanoMovie("Direct", gPanoMovieID, "set", "hPanAngle", string(pHPan))
    PanoMovie("Direct", gPanoMovieID, "set", "quality", string(pSwingQuality))
    PanoMovie("Direct", gPanoMovieID, "set", "transitionMode", "swing")
    PanoMovie("Direct", gPanoMovieID, "set", "transitionSpeed", string(pSwingSpeed))
    PanoMovie("Direct", gPanoMovieID, "update")
    PanoMovie("Direct", gPanoMovieID, "set", "transitionMode", "normal")
    if pFinalQuality <> pSwingQuality then
      PanoMovie("Direct", gPanoMovieID, "set", "quality", string(pFinalQuality))
      PanoMovie("Direct", gPanoMovieID, "update")
    end if
  end if
end

on CollapsePanoMovie.mac
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    PanoMovie("Direct", gPanoMovieID, "CollapseToHotSpotRgn")
  end if
end

on SetPanoMovieView pHPan, pVPan, pZoom, pQuality
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    PanoMovie("Direct", gPanoMovieID, "set", "zoomAngle", pZoom)
    PanoMovie("Direct", gPanoMovieID, "set", "vPanAngle", pVPan)
    PanoMovie("Direct", gPanoMovieID, "set", "hPanAngle", pHPan)
    if not voidp(pQuality) then
      PanoMovie("Direct", gPanoMovieID, "set", "quality", pQuality)
    end if
    PanoMovie("Direct", gPanoMovieID, "update")
  end if
end

on ClosePanoMovie.mac
  global gPanoMovieID
  if gPanoMovieID <> EMPTY then
    PanoMovie("Direct", gPanoMovieID, "dispose")
    set gPanoMovieID to EMPTY
  end if
end

on PanoFrameScript.mac pSpriteNum
  global gLastTimeRollover, gHotSpot, gPanoMovieID, gLastPanoMovieData, gPathName, gNavMovieID, gPanoFrame
  if rollOver(pSpriteNum) then
    if (gPanoMovieID <> EMPTY) and (RunningInForeground() = "true") then
      PanoMovie("Direct", gPanoMovieID, "mouseOver")
      set tMouseOverResult to the result
      if tMouseOverResult <> 0 then
        set tAction to item 1 of tMouseOverResult
        if tAction = "jump" then
        else
          if tAction = "stil" then
            put item 2 of tMouseOverResult into field "Current Hot Spot ID"
          else
            if tAction = "navg" then
              set tHotSpotID to item 2 of tMouseOverResult
              put tHotSpotID into field "Current Hot Spot ID"
              set tStartZoom to PanoMovie("Direct", gPanoMovieID, "get", "navgZoomRect")
              set tViewAngles to PanoMovie("Direct", gPanoMovieID, "get", "navgViewAngles")
              set tFileName to PanoMovie("Direct", gPanoMovieID, "get", "hotSpotName")
              CollapsePanoMovie()
              OpenNavMovie(gPathName & ":" & tFileName, 2, 0)
              if gNavMovieID <> EMPTY then
                set gPanoFrame to marker(0)
                go(the frame)
                SetNavMovieView(item 1 of tViewAngles, item 2 of tViewAngles)
                set tClipRect to the left of sprite pSpriteNum & "," & the top of sprite pSpriteNum & "," & the right of sprite pSpriteNum & "," & the bottom of sprite pSpriteNum
                ZoomNavMovie(tStartZoom, "true", tClipRect)
              else
                PanoMovie("Direct", gPanoMovieID, "update")
              end if
            else
              if tAction = "misc" then
              else
                if tAction = "undf" then
                  if the mouseUp then
                    checkVRHotSpotClick()
                  end if
                else
                  if tAction = "pan " then
                  end if
                end if
              end if
            end if
          end if
        end if
        set gLastTimeRollover to 1
      else
        if rollOver(pSpriteNum) then
          set gLastTimeRollover to 1
        else
          cursor(200)
          cursor(-1)
          set gLastTimeRollover to 0
        end if
      end if
    end if
  else
    if gLastTimeRollover then
      cursor(200)
      cursor(-1)
      set gLastTimeRollover to 0
      if gPanoMovieID <> EMPTY then
        PanoMovie("Direct", gPanoMovieID, "idle")
      end if
    end if
  end if
end

on getpanoloc
  global gPC
  if gPC then
    GetPanoLoc.PC()
  else
    GetPanoLoc.Mac()
  end if
end

on GetPanoLoc.PC
  global gPanoMovieObj
  set zoom to gPanoMovieObj(mGetZoomAngle)
  set vpan to gPanoMovieObj(mGetVPanAngle)
  set hpan to gPanoMovieObj(mGetHPanAngle)
  put "HPan:" && hpan
  put "VPan:" && vpan
  put "PZoom:" && zoom
end

on GetPanoLoc.Mac
  global gPanoMovieID
  set zoom to PanoMovie("Direct", gPanoMovieID, "get", "zoomAngle", string(pZoom))
  set vpan to PanoMovie("Direct", gPanoMovieID, "get", "vPanAngle", string(pVPan))
  set hpan to PanoMovie("Direct", gPanoMovieID, "get", "hPanAngle", string(pHPan))
  put "HPan:" && hpan
  put "VPan:" && vpan
  put "PZoom:" && zoom
end
