global gPC, gWinInfoOpen, oWinInfo, gNetscapeFound, gNetscapeLocation, gIExplorerFound, gIExplorerLocation, gOtherBrowserFound, gOtherBrowserLocation

on SetUpBrowser
  cursor(4)
  SetInfo("Searching for Browsers")
  set INIBrowserName to ReadPreferenceData()
  set BrowserInINIExists to FileExists(INIBrowserName)
  if BrowserInINIExists then
    put INIBrowserName into field "BrowserLocation"
    CheckBrowserType(INIBrowserName)
  else
    put "** Previously selected Internet Browser not found **" into field "BrowserLocation"
    set gOtherBrowserFound to 0
  end if
  if not gNetscapeFound then
    NetscapeExists()
  end if
  if not gIExplorerFound then
    ExplorerExists()
  end if
  set BrowserWasFound to gNetscapeFound or gIExplorerFound or gOtherBrowserFound
  if not BrowserWasFound then
    put "** No Browser **" into field "BrowserLocation"
  end if
  cursor(-1)
end

on ReadPreferenceData
  if gPC then
    set INIBrowserName to ReadBrowserFromINI()
  else
    set INIBrowserName to readBrowserFromPref()
  end if
  return INIBrowserName
end

on CheckBrowserType PassedBrowserName
  set gIExplorerFound to 0
  set gNetscapeFound to 0
  set gOtherBrowserFound to 0
  set ItemSeparator to ":"
  if gPC then
    set ItemSeparator to "\"
  end if
  set the itemDelimiter to ItemSeparator
  set TotalItems to the number of items in PassedBrowserName
  set BrowserName to item TotalItems of PassedBrowserName
  if BrowserName contains "explore" then
    set gIExplorerFound to 1
    set gIExplorerLocation to BrowserName
  else
    if BrowserName contains "navig" then
      set gNetscapeFound to 1
      set gNetscapeLocation to BrowserName
    else
      if BrowserName contains "netsc" then
        set gNetscapeFound to 1
        set gNetscapeLocation to BrowserName
      else
        if FileExists(PassedBrowserName) then
          if not (gNetscapeFound or gIExplorerFound) then
            set gOtherBrowserFound to 1
          end if
        end if
      end if
    end if
  end if
end

on NetscapeExists
  set gNetscapeLocation to EMPTY
  set gNetscapeFound to 0
  if gPC then
    set NetscapeLocations to ["C:\Progra~1\NETSCAPE\Naviga~1\PROGRAM\netscape.exe", "C:\Progra~2\NETSCAPE\Naviga~1\PROGRAM\netscape.exe"]
    repeat with i in NetscapeLocations
      if FileExists(i) then
        set gNetscapeLocation to i
        set gNetscapeFound to 1
        exit repeat
      end if
    end repeat
  else
    set VolumeList to OSVolumeList()
    set SearchLines to the number of lines in VolumeList
    repeat with n = 1 to SearchLines
      set CurrentVolume to line n of VolumeList
      set SearchResult to OSSearchTypeCreator(CurrentVolume, "APPL", "MOSS", 1, 1)
      if SearchResult <> [] then
        set gNetscapeFound to 1
        set gNetscapeLocation to getAt(SearchResult, 1)
        exit repeat
      end if
    end repeat
  end if
end

on ExplorerExists
  set IExplorerLocation to EMPTY
  set IExplorerFoun to 0
  if gPC then
    set IExplorerLocations to ["C:\Progra~1\intern~1\IEXPLORE.EXE", "C:\Progra~2\intern~1\IEXPLORE.EXE"]
    repeat with i in IExplorerLocations
      if FileExists(i) then
        set gIExplorerLocation to i
        set gIExplorerFound to 1
        exit repeat
      end if
    end repeat
  else
    set VolumeList to OSVolumeList()
    set SearchLines to the number of lines in VolumeList
    repeat with n = 1 to SearchLines
      set CurrentVolume to line n of VolumeList
      set SearchResult to OSSearchTypeCreator(CurrentVolume, "APPL", "MSIE", 1, 1)
      if SearchResult <> [] then
        set gIExplorerFound to 1
        set gIExplorerLocation to getAt(SearchResult, 1)
        exit repeat
      end if
    end repeat
  end if
end

on AskForBrowser
  set fileType to "APPL"
  if gPC then
    set fileType to "EXE"
  end if
  set oFileObj to FileIO(mnew, "?READ", fileType)
  if objectp(oFileObj) then
    set theFileSelected to oFileObj(mFileName)
    oFileObj(mdispose)
  else
    set theFileSelected to "**NoBrowser**"
    set gOtherBrowserFound to 0
  end if
  return theFileSelected
end

on readBrowserFromPref
  set FolderLocation to OSSpecialPath("pref")
  set PrefFile to FolderLocation & ":Texas Prefs"
  set BrowserName to "*** No Browser Found ***"
  if FileExists(PrefFile) then
    set oPref to FileIO(mnew, "READ", PrefFile)
    set BrowserName to oPref(mReadFile)
    oPref(mdispose)
  end if
  return BrowserName
end

on ReadBrowserFromINI
  OpenWinInfo()
  set Section to "Browser"
  set Entry to "Current"
  set Default to "C:\Program Files\NETSCAPE\Navigator\PROGRAM\netscape.exe"
  set fileName to "DAI.INI"
  set INIEntry to oWinInfo(mReadPrivateProfile, Section, Entry, Default, fileName)
  return INIEntry
end

on WriteBrowserToINI theBrowserPath
  if gPC then
    OpenWinInfo()
    set Section to "Browser"
    set Entry to "Current"
    set fileName to "DAI.INI"
    set res to oWinInfo(mWritePrivateProfile, Section, Entry, theBrowserPath, fileName)
  else
    set FolderLocation to OSSpecialPath("pref")
    set PrefFile to FolderLocation & ":Texas Prefs"
    set oPref to FileIO(mnew, "WRITE", PrefFile)
    if objectp(oPref) then
      set res to oPref(mWriteString, theBrowserPath)
      oPref(mdispose)
    else
      alert("Could not save Preferences:" && oPref)
      abort()
    end if
  end if
  return res
end

on FileExists WhatFile
  set oFileObject to FileIO(mnew, "READ", WhatFile)
  set DoesExist to objectp(oFileObject)
  if DoesExist then
    oFileObject(mdispose)
  end if
  return DoesExist
end

on OpenWinInfo
  if gPC then
    if not gWinInfoOpen then
      openXLib(the pathName & "Xtras\WinInfo.DLL")
      set gWinInfoOpen to 1
    end if
    if not objectp(oWinInfo) then
      set oWinInfo to WinInfo(mnew)
    end if
  end if
end
